        PRINT "              HOMOGENEISATION DES DONNEES PAR A.C.P."
        PRINT "     (programme crit en QuickBASIC par J.P. Laborde, Mai1996)"
        PRINT : PRINT "Ce programme permets decombler les lacunes a partir  d'une"
        PRINT "analyse en composantes principales."
        PRINT "Les donnees sont sauvegardes dans un fichier TEXTE d'Excel 'DONBT.TXT'"
        PRINT "Le nombre nombre total de variables et celui des observations est seulement "
        PRINT "limit par la taille memoire."

        OPEN "C:\HYDROLAB\RESBT.TXT" FOR OUTPUT AS #2
        OPEN "C:\HYDROLAB\DETRESBT.TXT" FOR OUTPUT AS #3
        PRINT #3, "Evolution des estimations"
        PRINT #3, "Iteration" + CHR$(9) + "Variable" + CHR$(9) + "Annee" + CHR$(9) + "valeur manquante" + CHR$(9)
        PRINT "Je lis les caractristiques du travail dans le fichier DONBT.TXT"
        OPEN "C:\HYDROLAB\DONBT.TXT" FOR INPUT AS #1
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        a$ = RIGHT$(a$, LEN(a$) - n)
        n = INSTR(a$, CHR$(9))
        nv = VAL(LEFT$(a$, n - 1))
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        a$ = RIGHT$(a$, LEN(a$) - n)
        n = INSTR(a$, CHR$(9))
        no = VAL(LEFT$(a$, n - 1))
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        a$ = RIGHT$(a$, LEN(a$) - n)
        n = INSTR(a$, CHR$(9))
        nc = VAL(LEFT$(a$, n - 1))
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        a$ = RIGHT$(a$, LEN(a$) - n)
        n = INSTR(a$, CHR$(9))
        nit = VAL(LEFT$(a$, n - 1))
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        a$ = RIGHT$(a$, LEN(a$) - n)
        PRINT "Il y a au total"; nv; "variables et"; no; "observations."
        PRINT "On valuera les"; nc; "premires composantes"
        PRINT " Les lacunes seront bouches aprs "; nit; " itrations."
        PRINT
        e$ = ""
        DIM x(no, nv), in(no, nv), m(nv), s(nv), r(nv, nv), nv$(nv), no$(no), vo(nc, nv), v1(nv), l(nc)
        FOR i = 1 TO no
            FOR j = 1 TO nv
                in(i, j) = 0
            NEXT j
        NEXT i


        PRINT "Je lis et convertis les donnes venant du fichier DONBT.TXT"
        FOR i = 1 TO nv - 1
            n = INSTR(a$, CHR$(9))
            nv$(i) = LEFT$(a$, n - 1)
            a$ = RIGHT$(a$, LEN(a$) - n)
        NEXT i
        n = INSTR(a$, CHR$(9))
        IF n = 0 THEN nv$(nv) = a$: GOTO 3
        nv$(nv) = LEFT$(a$, n - 1)
3      FOR i = 1 TO no
            LINE INPUT #1, a$
            n = INSTR(a$, CHR$(9))
            no$(i) = LEFT$(a$, n - 1)
            a$ = RIGHT$(a$, LEN(a$) - n)
            FOR j = 1 TO nv - 1
                n = INSTR(a$, CHR$(9))
                b$ = LEFT$(a$, n - 1)
                a$ = RIGHT$(a$, LEN(a$) - n)
                IF INSTR(b$, "a") + INSTR(b$, "A") >= 1 THEN in(i, j) = 1: GOTO 11
                n = INSTR(b$, ",")
                IF n >= 1 THEN MID$(b$, n) = "."
                x(i, j) = VAL(b$)
11        NEXT j
        IF INSTR(a$, "a") + INSTR(a$, "A") >= 1 THEN in(i, nv) = 1: GOTO 12
            n = INSTR(a$, ",")
            IF n >= 1 THEN MID$(a$, n) = "."
            x(i, nv) = VAL(a$)
12    NEXT i
        CLOSE #1
        PRINT "J'initialise les valeurs manquantes"
        FOR i = 1 TO nv
            m(i) = 0: s(i) = 0: r(i, i) = 0
            n = no
            FOR j = 1 TO n
                IF in(j, i) > .5 THEN 13
                m(i) = m(i) + x(j, i): r(i, i) = r(i, i) + x(j, i) ^ 2
                s(i) = s(i) + 1
13       NEXT j
         m(i) = m(i) / s(i)
         r(i, i) = ((r(i, i) - s(i) * m(i) ^ 2) / (s(i) - 1)) ^ .5
        NEXT i
        FOR j = 1 TO n
        x(j, 0) = 0
        in(j, 0) = 0
        FOR i = 1 TO nv
                IF in(j, i) < .5 THEN x(j, 0) = x(j, 0) + (x(j, i) - m(i)) / r(i, i): in(j, 0) = in(j, 0) + 1
        NEXT i
       
        x(j, 0) = x(j, 0) / in(j, 0)
        NEXT j
        FOR i = 1 TO nv
          IF no - s(i) = 0 THEN 17
            PRINT "Pour la variable "; nv$(i); ", il manque "; no - s(i); " observations remplaces par "; m(i)
            FOR j = 1 TO n
                IF in(j, i) > .5 THEN x(j, i) = m(i) + x(j, 0) * r(i, i)
            NEXT j
17       NEXT i
        FOR kk = 1 TO nit
        PRINT "Itration "; kk; " sur "; nit
        PRINT "Je calcule les moyennes, carts-types et coefficients de corrlation."
        FOR i = 1 TO nv
            m(i) = 0: s(i) = 0
            n = no
            FOR j = 1 TO n
                m(i) = m(i) + x(j, i)
                s(i) = s(i) + x(j, i) ^ 2
            NEXT j
            m(i) = m(i) / n
            s(i) = SQR((s(i) - n * m(i) ^ 2) / (n - 1))
        NEXT i
        FOR i = 1 TO nv - 1
            r(i, i) = 1
            FOR j = i + 1 TO nv
                r(i, j) = 0
                FOR k = 1 TO n
                    r(i, j) = r(i, j) + x(k, i) * x(k, j)
                NEXT k
                r(i, j) = (r(i, j) - n * m(i) * m(j)) / (n - 1) / s(i) / s(j)
                r(j, i) = r(i, j)
            NEXT j
        NEXT i
        r(nv, nv) = 1
        ns = nv
        ni = 0
        PRINT "Je calcule les valeurs propres et vecteurs propres des composantes"
        FOR k = 1 TO nc
            IF kk <> 1 THEN 71
            IF k <> 1 THEN 71
            GOTO 61
71           FOR i = 1 TO ns
                FOR j = i TO ns
                    r(i, j) = r(i, j) - l(k - 1) * vo(k - 1, i) * vo(k - 1, j)
                    r(j, i) = r(i, j)
                NEXT j
            NEXT i
61        FOR i = 1 TO ns
               vo(k, i) = 1
            NEXT i
            ni = 1
68        FOR i = 1 TO ns
                v1(i) = 0
                FOR j = 1 TO ns
                    v1(i) = v1(i) + r(i, j) * vo(k, j)
                NEXT j
            NEXT i
            d = 0
            FOR i = 1 TO ns
                IF ABS(v1(i)) > d THEN d = v1(i)
            NEXT i
            j = -1
            d = 1 / d
            ni = ni + 1
            FOR i = 1 TO ns
                v1(i) = v1(i) * d
                IF vo(k, i) = 0 THEN dr = v1(i): GOTO 90
                dr = v1(i) / vo(k, i) - 1
90            IF ABS(dr) > .01 THEN j = 1
            NEXT i
            FOR i = 1 TO ns
                vo(k, i) = v1(i)
            NEXT i
            IF ni = 100 THEN j = -1
            IF j = 1 THEN 68
            l(k) = 1 / d
            n = 0
            FOR i = 1 TO ns
                n = n + v1(i) ^ 2
            NEXT i
            n = 1 / SQR(n)
            FOR i = 1 TO ns
                vo(k, i) = v1(i) * n
            NEXT i
            PRINT "Lambda"; k; "="; l(k); "  (aprs"; ni; "itrations), "; INT(l(k) / nv * 100 + .5); "% de variance explique"
        NEXT k
        PRINT "Je bouche les trous  partir des projections des observations sur les composantes "
        emo = 0: ema = 0: emi = 0: ems = 0: nem = 0
        FOR k = 1 TO no
             FOR i = 1 TO nc
                 a = 0
                 FOR j = 1 TO ns
                     a = a + (x(k, j) - m(j)) / s(j) * vo(i, j)
                 NEXT j
                 a = a / SQR(l(i))
                 v1(i) = a
            NEXT i
            FOR i = 1 TO nv
                IF in(k, i) < .5 THEN 15
                a$ = STR$(kk - 1) + CHR$(9) + nv$(i) + CHR$(9) + no$(k) + CHR$(9)
                C$ = STR$(x(k, i))
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + C$ + CHR$(9)
                 ex = x(k, i)
                x(k, i) = m(i)
                FOR C = 1 TO nc
                    x(k, i) = x(k, i) + s(i) * v1(C) * vo(C, i) * SQR(l(C))
                NEXT C
                ex = (ex - x(k, i)) / s(i)
                emo = emo + ex
                ems = ems + ex * ex
                emn = emn + 1
                IF ex < emi THEN emi = ex
                IF ex > ema THEN ema = ex
                C$ = STR$(x(k, i))
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + CHR$(9)
               PRINT #3, a$
15        NEXT i
        NEXT k
        emo = emo / emn
        ems = SQR((ems - emn * emo * emo) / (emn - 1))
        a$ = "Iteration " + STR$(kk) + CHR$(9)
                C$ = STR$(emo)
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + C$ + CHR$(9)
                C$ = STR$(ems)
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + C$ + CHR$(9)
                C$ = STR$(emi)
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + C$ + CHR$(9)
                C$ = STR$(ema)
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                 a$ = a$ + C$ + CHR$(9)

        FOR i = 1 TO nc
                C$ = STR$(l(i))
                n = INSTR(C$, ".")
                IF n >= 1 THEN MID$(C$, n) = ","
                a$ = a$ + CHR$(9) + C$
        NEXT i
                PRINT "Moyenne de l'erreur rduite :"; INT(emo * 100 + .5); "%"
                PRINT "Ecart-type de l'erreur rduite :"; INT(ems * 100 + .5); "%"
                PRINT "Erreur rduite maximale :"; INT(ema * 100 + .5); "%"
                PRINT "Erreur rduite minimale :"; INT(emi * 100 + .5); "%"
        NEXT kk
    a$ = "DONNEES COMPLETEES A PARTIR DE " + STR$(nc) + " COMPOSANTES ET APRES " + STR$(nit) + " ITERATIONS."
    PRINT #2, a$
    a$ = CHR$(9)
    FOR i = 1 TO nv
    a$ = a$ + nv$(i) + CHR$(9)
    NEXT i
    PRINT #2, a$
    FOR j = 1 TO no
         a$ = no$(j) + CHR$(9)
         FOR i = 1 TO nv
            C$ = STR$(x(j, i))
            n = INSTR(C$, ".")
            IF n >= 1 THEN MID$(C$, n) = ","
             a$ = a$ + C$ + CHR$(9)
        NEXT i
        PRINT #2, a$
    NEXT j

2  CLOSE #2
     PRINT "C'est fini, vous pouvez maintenant reprendre le fichier RESBT.txt dans Excel"
 END

