    CLS
    PRINT
    PRINT "                  Analyse en Composantes Principales           "
PRINT "          (programme crit en QuickBASIC par J.P. Laborde, Avril 1992 )"
PRINT : PRINT "Ce programme permets d'excuter une analyse en composantes principales"
PRINT " partir des donnes venant du fichier TEXTE d'Excel 'DONACP.TXT'"
PRINT "Le nombre nombre total de variables et celui des observations est seulement "
PRINT "limit par la taille memoire."
    PRINT "Je lis les caractristiques du travail dans le fichier 'DONACP.TXT"
    CLS
    OPEN "C:\HYDROLAB\DONACP.txt" FOR INPUT AS #1
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    nv = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    no = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    vs = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    os = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    nc = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
135 PRINT "Il y a au total"; nv; "variables et"; no; "observations."
    PRINT "(dont"; nv - vs; "variables actives et"; vs; "variables supplmentaires )"
    PRINT "(dont"; no - os; "observations actives et"; os; "observations supplmentaires )"
    PRINT "On valuera les"; nc; "premires composantes"
    PRINT
    DIM x(no, nv), m(nv), s(nv), r(nv, nv), nv$(nv), no$(no), vo(nc, nv), v1(nv), l(nc)
    PRINT "Je lis et convertis les donnes venant du fichier DONACP.txt"
    FOR i = 1 TO nv - 1
        n = INSTR(a$, CHR$(9))
        nv$(i) = LEFT$(a$, n - 1)
        a$ = RIGHT$(a$, LEN(a$) - n)
    NEXT i
    n = INSTR(a$, CHR$(9))
    IF n = 0 THEN nv$(nv) = a$: GOTO 3
    nv$(nv) = LEFT$(a$, n - 1)
3    FOR i = 1 TO no
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        no$(i) = LEFT$(a$, n - 1)
        a$ = RIGHT$(a$, LEN(a$) - n)
        FOR j = 1 TO nv - 1
            n = INSTR(a$, CHR$(9))
            b$ = LEFT$(a$, n - 1)
            a$ = RIGHT$(a$, LEN(a$) - n)
            n = INSTR(b$, ",")
            IF n >= 1 THEN MID$(b$, n) = "."
            x(i, j) = VAL(b$)
        NEXT j
        n = INSTR(a$, ",")
        IF n >= 1 THEN MID$(a$, n) = "."
        x(i, nv) = VAL(a$)
    NEXT i
    CLOSE #1
   PRINT "Je calcule les moyennes, carts-types et coefficients de corrlation."
    FOR i = 1 TO nv
        m(i) = 0: s(i) = 0
        n = no - os
        FOR j = 1 TO n
            m(i) = m(i) + x(j, i)
            s(i) = s(i) + x(j, i) ^ 2
        NEXT j
        m(i) = m(i) / n
        s(i) = SQR((s(i) - n * m(i) ^ 2) / (n - 1))
    NEXT i
    FOR i = 1 TO nv - 1
        r(i, i) = 1
        FOR j = i + 1 TO nv
            r(i, j) = 0
            FOR k = 1 TO n
                r(i, j) = r(i, j) + x(k, i) * x(k, j)
            NEXT k
            r(i, j) = (r(i, j) - n * m(i) * m(j)) / (n - 1) / s(i) / s(j)
            r(j, i) = r(i, j)
        NEXT j
    NEXT i
    r(nv, nv) = 1
    PRINT "Je stocke ces rsultats dans le fichier RESACP.txt"
    OPEN "C:\HYDROLAB\RESACP.txt" FOR OUTPUT AS #2
    PRINT #2, "Caracteristiques de l'Analyse en Composantes Principales :"
    PRINT #2, STR$(nv - vs) + CHR$(9) + "variables actives"
    PRINT #2, STR$(vs) + CHR$(9) + "variables supplementaires"
    PRINT #2, STR$(no - os) + CHR$(9) + "observations actives"
    PRINT #2, STR$(os) + CHR$(9) + "observations supplementaires"
    PRINT #2, STR$(nc) + CHR$(9) + "premieres composantes principales etudiees"
    PRINT #2, "Moyennes des observations actives :"
    a$ = ""
    FOR i = 1 TO nv
    c$ = STR$(m(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    a$ = "Ecarts-types des observations actives :"
    PRINT #2, a$
    a$ = ""
    FOR i = 1 TO nv
    c$ = STR$(s(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    PRINT #2, "Matrice des coefficients de correlation :"
    a$ = ""
    FOR i = 1 TO nv
    a$ = a$ + CHR$(9) + nv$(i)
    NEXT i
    PRINT #2, a$
    FOR i = 1 TO nv
    a$ = nv$(i)
    FOR j = 1 TO nv
    c$ = STR$(r(i, j))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT j
    PRINT #2, a$
    NEXT i
    ns = nv - vs
    ni = 0
    PRINT "Je calcule les valeurs propres et vecteurs propres des composantes"
    FOR k = 1 TO nc
        IF k = 1 THEN 61
        FOR i = 1 TO ns
            FOR j = i TO ns
                r(i, j) = r(i, j) - l(k - 1) * vo(k - 1, i) * vo(k - 1, j)
                r(j, i) = r(i, j)
            NEXT j
        NEXT i
61    FOR i = 1 TO ns
           vo(k, i) = 1
        NEXT i
        ni = 1
68    FOR i = 1 TO ns
            v1(i) = 0
            FOR j = 1 TO ns
                v1(i) = v1(i) + r(i, j) * vo(k, j)
            NEXT j
        NEXT i
        d = 0
        FOR i = 1 TO ns
            IF ABS(v1(i)) > d THEN d = v1(i)
        NEXT i
        j = -1
        d = 1 / d
        ni = ni + 1
        FOR i = 1 TO ns
            v1(i) = v1(i) * d
            IF vo(k, i) = 0 THEN dr = v1(i): GOTO 90
            dr = v1(i) / vo(k, i) - 1
90        IF ABS(dr) > .01 THEN j = 1
        NEXT i
        
        FOR i = 1 TO ns
            vo(k, i) = v1(i)
        NEXT i
        IF ni = 100 THEN j = -1
        IF j = 1 THEN 68
        l(k) = 1 / d
        n = 0
        FOR i = 1 TO ns
            n = n + v1(i) ^ 2
        NEXT i
        n = 1 / SQR(n)
        FOR i = 1 TO ns
            vo(k, i) = v1(i) * n
        NEXT i
        PRINT "Composante"; k; "     Lambda ="; l(k); "  (aprs"; ni; "itrations)"
    NEXT k
    PRINT "Je calcule les projections des observations sur les composantes "
    IF vs = 0 THEN 27
    FOR k = 1 TO nc
        FOR i = ns + 1 TO nv
            vo(k, i) = 0
            FOR j = 1 TO ns
                vo(k, i) = vo(k, i) + r(i, j) * vo(k, j)
            NEXT j
            vo(k, i) = vo(k, i) / l(k)
        NEXT i
    NEXT k
    PRINT "Je stocke ces rsultats dans le fichier RESACP.txt"
27 a$ = "Valeurs propres :"
    PRINT #2, a$
    b$ = CHR$(9) + "C1"
    FOR i = 2 TO nc
        b$ = b$ + CHR$(9) + "C" + STR$(i)
    NEXT i
    PRINT #2, b$
    a$ = ""
    FOR i = 1 TO nc
        c$ = STR$(l(i))
        n = INSTR(c$, ".")
        IF n >= 1 THEN MID$(c$, n) = ","
        a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    a$ = "Variances expliquees :"
    PRINT #2, a$
    PRINT #2, b$
    a$ = ""
    FOR i = 1 TO nc
        c$ = STR$(l(i) / ns)
        n = INSTR(c$, ".")
        IF n >= 1 THEN MID$(c$, n) = ","
        a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    a$ = "Variances cumulees :"
    PRINT #2, a$
    PRINT #2, b$
    c$ = STR$(l(1) / ns)
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = CHR$(9) + c$
    a = l(1)
    FOR i = 2 TO nc
        a = a + l(i)
        c$ = STR$(a / ns)
        n = INSTR(c$, ".")
        IF n >= 1 THEN MID$(c$, n) = ","
        a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    a$ = "Projections des variables actives :"
    PRINT #2, a$
    PRINT #2, b$
    FOR j = 1 TO ns
        a$ = nv$(j)
        FOR i = 1 TO nc
            c$ = STR$(vo(i, j) * SQR(l(i)))
            n = INSTR(c$, ".")
            IF n >= 1 THEN MID$(c$, n) = ","
            a$ = a$ + CHR$(9) + c$
        NEXT i
        PRINT #2, a$
    NEXT j
    a$ = "Projections des variables supplementaires :"
    PRINT #2, a$
    PRINT #2, b$
    IF vs = 0 THEN 1
    FOR j = ns + 1 TO nv
        a$ = nv$(j)
        FOR i = 1 TO nc
            c$ = STR$(vo(i, j) * SQR(l(i)))
            n = INSTR(c$, ".")
            IF n >= 1 THEN MID$(c$, n) = ","
            a$ = a$ + CHR$(9) + c$
        NEXT i
        PRINT #2, a$
    NEXT j
1  PRINT #2, "Projections des observations actives"
     PRINT #2, b$
     FOR k = 1 TO no - os
         a$ = no$(k)
         FOR i = 1 TO nc
             a = 0
             FOR j = 1 TO ns
                 a = a + (x(k, j) - m(j)) / s(j) * vo(i, j)
             NEXT j
             a = a / SQR(l(i))
            c$ = STR$(a)
            n = INSTR(c$, ".")
            IF n >= 1 THEN MID$(c$, n) = ","
             a$ = a$ + CHR$(9) + c$
        NEXT i
        PRINT #2, a$
    NEXT k
    PRINT #2, "Projections des observations supplementaires :"
     PRINT #2, b$
    IF os = 0 THEN 2
     FOR k = no - os + 1 TO no
         a$ = no$(k)
         FOR i = 1 TO nc
             a = 0
             FOR j = 1 TO ns
                 a = a + (x(k, j) - m(j)) / s(j) * vo(i, j)
             NEXT j
             a = a / SQR(l(i))
            c$ = STR$(a)
            n = INSTR(c$, ".")
            IF n >= 1 THEN MID$(c$, n) = ","
             a$ = a$ + CHR$(9) + c$
        NEXT i
        PRINT #2, a$
    NEXT k
2  CLOSE #2
     PRINT "C'est fini, vous pouvez maintenant reprendre le fichier RESACP.txt  sur Excel."
 END

