    CLS
    PRINT
    PRINT "             Rgression multiple linaire"
PRINT "          (programme crit en QuickBASIC par J.P. Laborde, Avril 1992 )"
PRINT : PRINT "Ce programme permets d'excuter une succession de rgressions multiples"
PRINT " partir des donnes venant du fichier TEXTE d'Excel 'DONREG.TXT'"
PRINT "Le nombre nombre total de variables et celui des observations est seulement "
PRINT "limit par la taille memoire."
    PRINT "Je lis les caractristiques du travail dans le fichier 'DONREG.TXT"
    OPEN "C:\HYDROLAB\DONREG.txt" FOR INPUT AS #1
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    nv = VAL(LEFT$(a$, n - 1))
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    n = INSTR(a$, CHR$(9))
    no = VAL(LEFT$(a$, n - 1))
    CLS
    PRINT "Il y a au total"; nv; "variables et"; no; "observations."
    DIM x(no, nv), m(nv), s(nv), r(nv, nv), nv$(nv), no$(no), a(nv, nv), d(nv), rp(nv), b(nv)
    IF nv < 2 THEN PRINT "Il n'y a pas assez de variables (2 au minimum)": END
     PRINT "Je lis et convertis les donnes venant du fichier DONREG.TXT"
    LINE INPUT #1, a$
    n = INSTR(a$, CHR$(9))
    a$ = RIGHT$(a$, LEN(a$) - n)
    FOR i = 1 TO nv - 1
        n = INSTR(a$, CHR$(9))
        nv$(i) = LEFT$(a$, n - 1)
        a$ = RIGHT$(a$, LEN(a$) - n)
    NEXT i
    n = INSTR(a$, CHR$(9))
    IF n = 0 THEN nv$(nv) = a$: GOTO 3
    nv$(nv) = LEFT$(a$, n - 1)
3    FOR i = 1 TO no
        LINE INPUT #1, a$
        n = INSTR(a$, CHR$(9))
        no$(i) = LEFT$(a$, n - 1)
        a$ = RIGHT$(a$, LEN(a$) - n)
        FOR j = 1 TO nv - 1
            n = INSTR(a$, CHR$(9))
            b$ = LEFT$(a$, n - 1)
            a$ = RIGHT$(a$, LEN(a$) - n)
            n = INSTR(b$, ",")
            IF n >= 1 THEN MID$(b$, n) = "."
            x(i, j) = VAL(b$)
        NEXT j
        n = INSTR(a$, ",")
        IF n >= 1 THEN MID$(a$, n) = "."
        x(i, nv) = VAL(a$)
    NEXT i
    CLOSE #1
   PRINT "Je calcule les moyennes, carts-types et coefficients de corrlation."
    FOR i = 1 TO nv
        m(i) = 0: s(i) = 0
        FOR j = 1 TO no
            m(i) = m(i) + x(j, i)
            s(i) = s(i) + x(j, i) ^ 2
        NEXT j
        m(i) = m(i) / no
        s(i) = SQR((s(i) - no * m(i) ^ 2) / (no - 1))
    NEXT i
    FOR i = 1 TO nv - 1
        r(i, i) = 1
        FOR j = i + 1 TO nv
            r(i, j) = 0
            FOR k = 1 TO no
                r(i, j) = r(i, j) + x(k, i) * x(k, j)
            NEXT k
            r(i, j) = (r(i, j) - no * m(i) * m(j)) / (no - 1) / s(i) / s(j)
            r(j, i) = r(i, j)
        NEXT j
    NEXT i
    r(nv, nv) = 1
    PRINT "Je stocke ces rsultats dans le fichier RESREG.TXT"
    OPEN "C:\HYDROLAB\RESREG.TXT" FOR OUTPUT AS #2
    PRINT #2, "Caracteristiques de la regression multiple lineaire :"
    PRINT #2, STR$(nv) + CHR$(9) + "variables au total"
    PRINT #2, STR$(nv - 1) + CHR$(9) + "variables explicatives"
    PRINT #2, "Moyennes des observations actives :"
    a$ = ""
    FOR i = 1 TO nv
    c$ = STR$(m(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    a$ = "Ecarts-types des observations actives :"
    PRINT #2, a$
    a$ = ""
    FOR i = 1 TO nv
    c$ = STR$(s(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT i
    PRINT #2, a$
    PRINT #2, "Matrice des coefficients de correlation :"
    a$ = ""
    FOR i = 1 TO nv
    a$ = a$ + CHR$(9) + nv$(i)
    NEXT i
    PRINT #2, a$
    FOR i = 1 TO nv
    a$ = nv$(i)
    FOR j = 1 TO nv
    c$ = STR$(r(i, j))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    NEXT j
    PRINT #2, a$
    NEXT i
    FOR i = 1 TO nv
    FOR j = 1 TO nv
    a(i, j) = r(i, j)
    NEXT j: NEXT i
10   nn = nv
      FOR i = 1 TO nv
    FOR j = 1 TO nv
    r(i, j) = a(i, j)
    NEXT j: NEXT i
    GOSUB 30
    r = p
    ics = 1
    FOR ib = 1 TO nv
    FOR i = 1 TO nv
    FOR j = 1 TO nv
    r(i, j) = a(i, j)
    NEXT j: NEXT i
    ls = ib
    GOSUB 20
    d(ib) = p
    NEXT ib
    FOR ib = 2 TO nv
    FOR i = 1 TO nv
    FOR j = 1 TO nv
    r(i, j) = a(i, j)
    NEXT j: NEXT i
    ls = ib
    ics = ib
    GOSUB 20
    rp(ib) = p
    NEXT ib
    r = 1 - r / d(1)
    cm = SQR(r)
    FOR i = 2 TO nv
    k = (-1) ^ (i + 1)
    b(i) = k * (-s(1)) / s(i) * d(i) / d(1)
    rp(i) = -d(i) * k / SQR((d(1) * rp(i)))
    NEXT i
    bo = m(1)
    FOR j = 2 TO nv
    bo = bo - b(j) * m(j)
    NEXT j
   PRINT "Regression avec "; nv - 1; " variables explicatives"
    PRINT "nom", "coef de reg", "coef de cor"
    FOR i = 2 TO nv
    PRINT nv$(i), b(i), rp(i)
    NEXT i
    PRINT "R="; cm
    PRINT "Bo="; bo
    rp = 1
    FOR i = 2 TO nv
    IF ABS(rp(i)) > rp THEN 11
    rp = ABS(rp(i))
    nr = i
11 NEXT i
    f1 = (no - nv) * r / (nv - 1) / (1 - r)
    PRINT "Test de Student-Fischer sur le coef de cor multiple"
    PRINT "F experimental : "; f1
    nu1 = nv - 1
    nu2 = no - nv
    z1 = ((1 - 2 / 9 / nu2) * f1 ^ .3333 - (1 - 2 / 9 / nu1)) / ((2 / 9 / nu2) * f1 ^ .66666 + 2 / 9 / nu1) ^ .5
    PRINT "seuil a 95% : "; fl
    IF z1 > 1.645 THEN PRINT "moins de 5% de chance d'etre du au hasard": GOTO 12
    PRINT "plus de 5 % de chance d'etre du au hasard"
    GOTO 14
12 nu = no - nv - 1
    PRINT "Test de Student sur le plus petit coef de cor par"
    f2 = ABS(rp)
    PRINT "valeur exp"; f2
    z2 = .5 * LOG((1 + f2) / (1 - f2)) * nu ^ .5
    IF z2 > 1.96 THEN PRINT "moins de 5% de chance d'etre du au hasard": GOTO 13
    PRINT "plus de 5 % de chance d'etre du au hasard"
    GOTO 14
13 PRINT "Cette derniere solution est acceptable"
    GOSUB 40
    PRINT #2, "Cette derniere solution est acceptable"
    CLOSE #2
    END
14 PRINT "Je supprime la variable "; nv$(nr)
    GOSUB 40
    PRINT #2, "Je supprime la variable"; CHR$(9); nv$(nr)
    PRINT #2, ""
    IF nv > 2 THEN 15
    PRINT " J'ai tout essaye"
    END
15   IF nr = nv THEN 16
    FOR i = nr TO nv - 1
    FOR j = 1 TO nv
    a(j, i) = a(j, i + 1)
    NEXT j
    m(i) = m(i + 1)
    s(i) = s(i + 1)
    nv$(i) = nv$(i + 1)
    NEXT i
    FOR i = nr TO nv - 1
    FOR j = 1 TO nv - 1
    a(i, j) = a(i + 1, j)
    NEXT j
    NEXT i
16   nv = nv - 1
    GOTO 10
20 FOR i = ls TO nv - 1
    IF ls = nv THEN 21
    FOR j = 1 TO nv
    r(i, j) = r(i + 1, j)
    NEXT j: NEXT i
21   FOR i = ics TO nv - 1
    IF ics = nv THEN 22
    FOR j = 1 TO nv - 1
    r(j, i) = r(j, i + 1)
    NEXT j: NEXT i
22 nn = nv - 1
    GOSUB 30
    RETURN
30   p = 1
    FOR i = 1 TO nn
    p = p * r(i, i): pj = r(i, i)
    FOR j = 1 TO nn
    r(i, j) = r(i, j) / pj
    NEXT j
    IF i = nn THEN 31
    FOR j = i + 1 TO nn
    c = r(j, i)
    FOR k = 1 TO nn
    r(j, k) = r(j, k) - r(i, k) * c
    NEXT k
    NEXT j
    NEXT i
31    IF p = 0 THEN PRINT "determinant nul": END
     RETURN
40    a$ = "Regression lineaire avec " + STR$(nv - 1) + " variables explicatives"
    PRINT #2, a$
    PRINT #2, "Variable" + CHR$(9) + "Coef. de reg." + CHR$(9) + "Coef. cor. partielle"
    FOR i = 2 TO nv
    a$ = nv$(i)
    c$ = STR$(b(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    c$ = STR$(rp(i))
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = a$ + CHR$(9) + c$
    PRINT #2, a$
   NEXT i
    c$ = STR$(bo)
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = "Terme constant :" + CHR$(9) + c$
        PRINT #2, a$
    c$ = STR$(cm)
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = "Coef. de cor. multiple :" + CHR$(9) + c$
   PRINT #2, a$
    c$ = STR$(f1)
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = "F exprimental :" + CHR$(9) + c$
IF z1 > 1.645 THEN a$ = a$ + CHR$(9) + "( " + STR$(z1) + "/1,645 significatif car ayant moins de 5% de chance d'etre du au hasard )"
IF z1 <= 1.645 THEN a$ = a$ + CHR$(9) + "( " + STR$(z1) + "/1,645 non-significatif car ayant plus de 5% de chance d'etre du au hasard )"
PRINT #2, a$
    c$ = STR$(f2)
    n = INSTR(c$, ".")
    IF n >= 1 THEN MID$(c$, n) = ","
    a$ = "Plus petit r :" + CHR$(9) + c$
    IF z2 > 1.96 THEN a$ = a$ + CHR$(9) + "( " + STR$(z2) + "/1,96 significatif car ayant moins de 5% de chance d'etre du au hasard )"
IF z2 <= 1.96 THEN a$ = a$ + CHR$(9) + "( " + STR$(z2) + "/1,96 non-significatif car ayant plus de 5% de chance d'etre du au hasard )"
PRINT #2, a$
RETURN



    

